(deftemplate auto
(slot naziv (type SYMBOL))
(slot vrsta (allowed-values limuzina sedan karavan hatchback kupe suv))
(slot zap_motora (type INTEGER))
(slot snaga (type INTEGER))
(slot gorivo (type SYMBOL))
(slot cena (type INTEGER))
(slot cert (type FLOAT)))

(deftemplate zahtev
(slot vrsta (allowed-values limuzina sedan karavan hatchback kupe suv))
(slot zap_motora (type INTEGER))
(slot snaga (type INTEGER))
(slot gorivo (type SYMBOL))
(slot cena (type INTEGER))
)

(deffacts automobili
(auto (naziv Opel_Corsa)(vrsta hatchback)(zap_motora 1200)(snaga 80)(gorivo benzin)(cena 12500))
(auto (naziv Opel_Astra)(vrsta hatchback)(zap_motora 1900)(snaga 120)(gorivo dizel)(cena 16500))
(auto (naziv Opel_Antara)(vrsta suv)(zap_motora 2000)(snaga 140)(gorivo dizel)(cena 29000))
(auto (naziv Opel_Insignia)(vrsta limuzina)(zap_motora 1600)(snaga 120)(gorivo benzin)(cena 22000))
(auto (naziv Opel_Tigra)(vrsta kupe)(zap_motora 1600)(snaga 120)(gorivo benzin)(cena 18000))
(auto (naziv Opel_Tigra1)(vrsta kupe)(zap_motora 1800)(snaga 120)(gorivo benzin)(cena 18100))
(auto (naziv Opel_Signum)(vrsta karavan)(zap_motora 2000)(snaga 140)(gorivo dizel)(cena 27000)))

(deffunction odstupanje (?a ?b)
(if (> 0.15 (/ (abs (- ?a ?b)) (max (abs ?a) (abs ?b)))) 
then (return TRUE)) 
(return FALSE))

(defrule p1
=>
(printout t "Vrsta?" crlf)
(assert (zahtev (vrsta (read))))
(printout t "Zapremina?" crlf)
(assert (zahtev (snaga (read))))
)

(defrule p2
(auto (naziv ?n)(vrsta ?v)(cena ?c1))
(zahtev (vrsta ?v)(cena ?c2))
(test (odstupanje ?c1 ?c2))
=>
(printout t "U nasoj ponudi je " ?n ", po ceni "?c1 crlf))